;==========================================================================
    include \masm32\include\masm32rt.inc
;==========================================================================
    .data
        _cyl  dd 0
        _head dd 0
        _sect dd 0
    .code
;==========================================================================

;---------------------------------------------------------------------
; Per the ATA standard for LBA numbers <= 16,514,064:
;   LBA = (((cyl * headsPerCyl) + head) * sectPerTrack) + sect - 1
;---------------------------------------------------------------------

GetLBA proc cyl:DWORD, head:DWORD, sect:DWORD,
            headsPerCyl:DWORD, sectPerTrack:DWORD

    mov eax, cyl
    mov ecx, headsPerCyl
    mul ecx
    add eax, head
    mov ecx, sectPerTrack
    mul ecx
    add eax, sect
    dec eax
    ret

GetLBA endp

;==========================================================================

;---------------------------------------------------------------------
; Transposing the above formula:
;   cyl = LBA / (headsPerCyl * sectPerTrack)
;   remainder = LBA MOD (headsPerCyl * sectPerTrack)
;   head = remainder / sectPerTrack
;   sect = remainder MOD sectPerTrack + 1
;---------------------------------------------------------------------

GetCHS proc lba:DWORD, headsPerCyl:DWORD, sectPerTrack:DWORD,
            pCyl:DWORD, pHead:DWORD, pSect:DWORD

    mov eax, headsPerCyl
    mov ecx, sectPerTrack
    mul ecx
    mov ecx, eax
    mov eax, lba
    xor edx, edx
    div ecx
    mov ecx, pCyl
    mov [ecx], eax
    push edx
    mov eax, edx
    mov ecx, sectPerTrack
    xor edx, edx
    div ecx
    mov ecx, pHead
    mov [ecx], eax
    pop eax
    mov ecx, sectPerTrack
    xor edx, edx
    div ecx
    inc edx
    mov ecx, pSect
    mov [ecx], edx
    ret

GetCHS endp
;==========================================================================
start:
;==========================================================================

    ;------------------------------------------------------
    ; 1.44MB = 80 cylinders, 18 sectors per track, 2 heads
    ;------------------------------------------------------

    xor ebx, ebx
    .WHILE ebx < (80 * 18 * 2)
        invoke GetCHS, ebx, 2, 18, ADDR _cyl, ADDR _head, ADDR _sect
        invoke GetLBA, _cyl, _head, _sect, 2, 18
        .IF eax != ebx
            print "error"
        .ENDIF
        inc ebx
    .ENDW

    xor ebx, ebx
    print "LBA",9,"Cyl",9,"Head",9,"Sect",13,10
    .WHILE ebx < 200
        invoke GetCHS, ebx, 2, 18, ADDR _cyl, ADDR _head, ADDR _sect
        print str$(ebx),9
        print str$(_cyl),9
        print str$(_head),9
        print str$(_sect),13,10
        inc ebx
    .ENDW

    inkey "Press any key to exit..."
    exit
;==========================================================================
end start
 